/*
 * FlexLED.h
 *
 *  Created on: Apr 9, 2019
 *      Author: a0222913
 */

#ifndef FLEXLED_H_
#define FLEXLED_H_

#define DATA_LENGTH_1                (0x00) //00b: Normal Mode;  10b: Burst
#define DATA_LENGTH_2                (0x10) //01b: Bust mode with 2 byte data;
#define DATA_LENGTH_4                (0x20) //10b: Burst mode with 4 byte data;
#define DATA_LENGTH_8                (0x30) //11b: Burst mode with 8 byte data

#define DEV_ADDR_0      (0x00) //device address = 0;
#define DEV_ADDR_1      (0x01) //device address = 1;
#define DEV_ADDR_2      (0x02) //device address = 2;
#define DEV_ADDR_3      (0x03) //device address = 3;
#define DEV_ADDR_4      (0x04) //device address = 4;
#define DEV_ADDR_5      (0x05) //device address = 5;
#define DEV_ADDR_6      (0x06) //device address = 6;
#define DEV_ADDR_7      (0x07) //device address = 7;
#define DEV_ADDR_8      (0x08) //device address = 8;
#define DEV_ADDR_9      (0x09) //device address = 9;
#define DEV_ADDR_10     (0x0A) //device address = 10;
#define DEV_ADDR_11     (0x0B) //device address = 11;
#define DEV_ADDR_12     (0x0C) //device address = 12;
#define DEV_ADDR_13     (0x0D) //device address = 13;
#define DEV_ADDR_14     (0x0E) //device address = 14;
#define DEV_ADDR_15     (0x0F) //device address = 15;

#define FLEX_Write      (0x80) //FlexWire write
#define FLEX_Read       (0x00) //FlexWire read

#define TRUE (0x01)
#define FALSE (0x00)

void portInitial();
//void s2Click(void);

void ucsInitial();
void oneMHzACLK(); //configure the SMCLK as 1MHz, ACLK as 1MHz
void fourMHzACLK(); //configure the SMCLK as 4MHz, ACLK as 1MHz

void timerInitial();
void delay(int delayTime);
void Timer0_A(void);
void Timer1_A(void);
void watchDog(int timeOut);
void uartInitial();

void dmaInitial();
void dmaTransfer(unsigned int dmaTxSize, unsigned int dmaRxSize, unsigned int checkResponse);

void FlexWrite(char DEV_ADDR_x, char registerAddr, char DATA_BYTES[], char DATA_LENGTH_x, unsigned int checkResponse);
void FlexRead(char DEV_ADDR_x, char registerAddr, char DATA_LENGTH_x);

void crcInitial();
char CRC_LUT(char commandFrame_withoutCRC[], unsigned int byteLength);

void greeting_and_goodbye(char deviceAddress);
void greeting_and_goodbye_2_devices(char startDeviceAddress);
void turnLeft(char startDeviceAddress, char mode);
void turnLeft_odd(char startDeviceAddress, char mode);
void greeting_and_goodbye_2_devices_odd(char startDeviceAddress);
void meteor_shower(char startDeviceAddress);

#endif /* FLEXLED_H_ */
