/*
 * IOPORT.c
 *
 *  Created on: May 27, 2019
 *      Author: a0222913
 */

#include <msp430.h>
#include <FlexLED.h>

extern char patternMode;

void portInitial()
{
    P1DIR |= BIT0; //set PI.0 output, work as error output
    P1REN |= BIT0; // enable pull up
    P1OUT &= ~BIT0; // turn off external error red LED

    P1DIR |= BIT1; //set P1.1 input, work as patterns mode selection input
//    P1REN |= BIT1; //enable P1.1 pull up resistor
    P1OUT |= BIT1; //set P1.1 high
    P1IES |= BIT1; //the P1IFG1 flag is set with a high-to-low transition
    P1IE |= BIT1; //enable P1.1 interrupt


    P3DIR |= BIT3; //P3.3 UART_TXD
    P3DS |= BIT3; //full drive strength
    P3SEL |= BIT3;
    P3DIR &= ~BIT4; //P3.4 UART_RXD
    P3OUT |= BIT4;
    P3REN |= BIT4; //enable P3.4 pull up resistor
    P3SEL |= BIT4;


    P2DIR |= BIT3 + BIT6; //P2.3 -> green_STB, P2.6 -> blue_STB
    P2OUT |= BIT3 + BIT6; //set STB as high to make two CAN transceivers enter Stand by Mode

}


#pragma vector = PORT1_VECTOR
__interrupt void s2Click(void)
{
    unsigned int i;
    P1IE &= ~BIT1; //disable P1.1 interrupt
    P1IFG &=~ BIT1;//clear flag
    patternMode++;
    i=10000;
    do
    {
        i--;
    }while(i>0);
    i=10000;
    do
    {
        i--;
    }while(i>0);
    i=10000;
    do
    {
        i--;
    }while(i>0);
//    delay(6625); //delay 50ms
    if(patternMode>2)
    {
        patternMode=0;
    }
    P1IE |= BIT1; //enable P1.1 interrupt
}

