/*
 * Patterns.c
 *
 *  Created on: Apr 22, 2019
 *      Author: a0222913
 */

#include <msp430.h>
#include <FlexLED.h>

extern char firstRun;
extern char turnFirstRun;
extern char GGFirstRun;

void greeting_and_goodbye(char deviceAddress)
{
    unsigned int j,k,m;
    char pwmStep[5]={0x00, 0x14, 0x3C, 0xA0, 0xFF};
    char data[8],dataLow[8], dataHigh[8];

    for(k=0;k<8;k++)
    {
        data[k]=0x00;
    }
    FlexWrite(deviceAddress, 0x20, data, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as data[k]
    FlexWrite(deviceAddress, 0x28, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as data[k]


//***greeting***********************//
    for(j=0;j<4;j++)
    {
        for(m=0;m<6;m++)
        {
            for(k=0;k<8;k++)
            {
                dataLow[k] = pwmStep[j];
                dataHigh[k] = pwmStep[j];
            }
            dataLow[5-m] = pwmStep[j+1];
            if(m<2)
            {
                dataLow[6+m] = pwmStep[j+1];
                FlexWrite(deviceAddress, 0x20, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
            }
            else
            {
                dataHigh[m-2] = pwmStep[j+1];
                FlexWrite(deviceAddress, 0x20, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
                FlexWrite(deviceAddress, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11
            }

            delay(13250);//delay 100ms
        }
        dataLow[0] = pwmStep[j];
        dataHigh[3] = pwmStep[j];
        FlexWrite(deviceAddress, 0x20, dataLow, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
        FlexWrite(deviceAddress, 0x2B, dataHigh, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7

        delay(13250);//delay 100ms

        data[0] = pwmStep[j+1];
        for(m=0;m<6;m++)
        {
            FlexWrite(deviceAddress, 0x25-m, data, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
            FlexWrite(deviceAddress, 0x26+m, data, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11

            delay(13250);//delay 100ms
        }
    }
    //***goodbye***********************//
    pwmStep[0] = 0xFF;
    pwmStep[1] = 0xA0;
    pwmStep[2] = 0x3C;
    pwmStep[3] = 0x14;
    pwmStep[4] = 0x00;

    for(j=0;j<4;j++)
    {
        for(m=0;m<5;m++)
        {
            for(k=0;k<8;k++)
            {
                dataLow[k] = pwmStep[j];
                dataHigh[k] = pwmStep[j];
            }

            dataLow[m+1] = pwmStep[j+1];
            if(m<3)
            {
                dataHigh[2-m] = pwmStep[j+1];
            }
            else
            {
                dataLow[10-m] = pwmStep[j+1];
            }
            FlexWrite(deviceAddress, 0x20, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
            FlexWrite(deviceAddress, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11

            delay(13250);//delay 100ms
        }
        dataLow[5] = pwmStep[j];
        dataLow[6] = pwmStep[j];
        FlexWrite(deviceAddress, 0x20, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7

        delay(13250);//delay 100ms

        data[0] = pwmStep[j+1];
        for(m=0;m<6;m++)
        {
            FlexWrite(deviceAddress, 0x20+m, data, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7
            FlexWrite(deviceAddress, 0x2B-m, data, DATA_LENGTH_1, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11

            delay(13250);//delay 100ms
        }
    }


}

void greeting_and_goodbye_2_devices(char startDeviceAddress) //2 devices with device address 1, 2.
{
    unsigned int j,k,m,n;
    char pwmStep[5]={0x00, 0x14, 0x3C, 0xA0, 0xFF}; //defined 4 different brightness steps
    char data[8];

    if(firstRun==1)
    {
        for(n=0;n<2;n++)
        {
            data[0]=0x00;
            FlexWrite(startDeviceAddress+n, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock the device
            for(k=0;k<8;k++)
            {
                data[k]=pwmStep[0];
            }
            FlexWrite(startDeviceAddress+n, 0x20, data, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as pwmStep[0]
            FlexWrite(startDeviceAddress+n, 0x28, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as pwmStep[0]
            data[0]=0x10;
            FlexWrite(startDeviceAddress+n, 0x56, data, DATA_LENGTH_1, TRUE); //enable LUT
            data[0]=0x83;
            FlexWrite(startDeviceAddress+n, 0x57, data, DATA_LENGTH_1, TRUE); //Set PWM frequency as 1000Hz
        }
        for(n=0;n<2;n++)
        {
            data[0]=0xFF;
            data[1]=0x0F;
            FlexWrite(startDeviceAddress+n, 0x50, data, DATA_LENGTH_2, TRUE); //write 0xFF, 0x0F to 0x50h and 0x51h, enable all channels for the device
        }

        firstRun=0;
    }

    //***welcome***********************//
    for(j=0;j<4;j++) // 4 different brightness ramp up
    {
        for(m=0;m<12;m++)
        {
            data[0]=pwmStep[j+1]; //assign to next brightness
            FlexWrite(startDeviceAddress, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1

            delay(5300);//delay 20ms

            data[0]=pwmStep[j]; //assign back to last brightness
            FlexWrite(startDeviceAddress, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1
        }
        for(m=0;m<12;m++)
        {
            data[0]=pwmStep[j+1]; //assign to next brightness
            FlexWrite(startDeviceAddress, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1

            delay(5300);//delay 20ms
        }
    }
    //***follow me home***********************//
        for(j=0;j<4;j++) // 4 different brightness ramp down
        {
            /*
            for(m=0;m<12;m++)
            {
                data[0]=pwmStep[3-j]; //assign to next brightness
                FlexWrite(startDeviceAddress, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from lowest channel to highest channel 1 by 1

                delay(2650);//delay 20ms

                data[0]=pwmStep[4-j]; //assign back to last brightness
                FlexWrite(startDeviceAddress, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from highest channel to lowest channel 1 by 1
            }
            */
            for(m=0;m<12;m++)
            {
                data[0]=pwmStep[3-j]; //assign to next brightness
                FlexWrite(startDeviceAddress, 0x20+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2B-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from highest channel to lowest channel 1 by 1

                delay(5300);//delay 20ms
            }
        }

}

void turnLeft(char startDeviceAddress, char mode)//mode=0, right to left
                                                 //mode=1, left to right
{
    unsigned int i=0;
    char data[8], dataHigh[8], dataLow[8];
    char chEnable0[8]={1,3,7,15,31,63,127,255};
    char chEnable1[12]={8,12,14,15,128,192,224,240,248,252,254,255};

    if(turnFirstRun==1)
    {


        //***Disable all channels for device 0
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x00 to 0x50h, 0x51h

        //***Disable all channels for device 1
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x03 to 0x50h, 0x51h
        //***Set DC for all Channels
        for(i=0;i<8;i++)
          {
              data[i]=0x3F;
          }
         FlexWrite(startDeviceAddress, 0x00, data, DATA_LENGTH_8, TRUE); //write CONF_IOUT0 to CONF_IOUT7 as 0x3F
         FlexWrite(startDeviceAddress, 0x08, data, DATA_LENGTH_4, TRUE); //write CONF_IOUT8 to CONF_IOUT11 as 0x3F
         for(i=0;i<8;i++)
           {
               data[i]=0x3F;
           }
         FlexWrite(startDeviceAddress+1, 0x00, data, DATA_LENGTH_8, TRUE); //write CONF_IOUT0 to CONF_IOUT7 as 0x1F
         FlexWrite(startDeviceAddress+1, 0x08, data, DATA_LENGTH_4, TRUE); //write CONF_IOUT8 to CONF_IOUT11 as 0x1F
        //***Set PWMOUT for all Channels
       for(i=0;i<8;i++)
       {
            dataLow[i]=15;
            dataHigh[i]=200; //255 -- 100%, 127 -- 50%, 25 -- 10%
       }
        FlexWrite(startDeviceAddress, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
        FlexWrite(startDeviceAddress, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow
        FlexWrite(startDeviceAddress+1, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
        FlexWrite(startDeviceAddress+1, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow

        FlexWrite(startDeviceAddress, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
        FlexWrite(startDeviceAddress, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh
        FlexWrite(startDeviceAddress+1, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
        FlexWrite(startDeviceAddress+1, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh

        turnFirstRun=0;
        i=0;

    }

    if(mode==0)
    {

        do
        {
            if(i<8)
            {
                data[0]=chEnable0[i];
                FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else if(i<12)
            {
                data[0]=chEnable0[i-8];
                FlexWrite(startDeviceAddress, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else if(i<20)
            {
                data[0]=chEnable0[i-12];
                FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else
            {
                data[0]=chEnable0[i-20];
                FlexWrite(startDeviceAddress+1, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            i++;
        }while(i<24);
//        delay(14575);//delay 110ms
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE);
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE);
        delay(29150);//delay 110ms
    }
    else
    {
        do
        {
            if(i<4)
            {
                data[0]=chEnable1[i];
                FlexWrite(startDeviceAddress+1, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else if(i<12)
            {
                data[0]=chEnable1[i];
                FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else if(i<16)
            {
                data[0]=chEnable1[i-12];
                FlexWrite(startDeviceAddress, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            else
            {
                data[0]=chEnable1[i-12];
                FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(3975);//delay 10ms
            }
            i++;
        }while(i<24);
//        delay(14575);//delay 110ms
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE);
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE);
        delay(29150);//delay 110ms
    }

}
void turnLeft_odd(char startDeviceAddress, char mode)//mode=0, right to left
                                                 //mode=1, left to right
{
    unsigned int i=0;
    char data[8], dataHigh[8], dataLow[8];
    char chEnable0[8]={1,5,21,85};
    char chEnable1[12]={8,10,128,160,168,170};

    if(turnFirstRun==1)
    {


        //***Disable all channels for device 0
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x00 to 0x50h, 0x51h

        //***Disable all channels for device 1
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x03 to 0x50h, 0x51h

        //***Set PWMOUT for all Channels
       for(i=0;i<8;i++)
       {
            dataLow[i]=15;
            dataHigh[i]=255; //255 -- 100%, 127 -- 50%, 25 -- 10%
       }
        FlexWrite(startDeviceAddress, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
        FlexWrite(startDeviceAddress, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow
        FlexWrite(startDeviceAddress+1, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
        FlexWrite(startDeviceAddress+1, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow

        FlexWrite(startDeviceAddress, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
        FlexWrite(startDeviceAddress, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh
        FlexWrite(startDeviceAddress+1, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
        FlexWrite(startDeviceAddress+1, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh

        turnFirstRun=0;
        i=0;

    }

    if(mode==0)
    {

        do
        {
            if(i<4)
            {
                data[0]=chEnable0[i];
                FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else if(i<6)
            {
                data[0]=chEnable0[i-4];
                FlexWrite(startDeviceAddress, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else if(i<10)
            {
                data[0]=chEnable0[i-6];
                FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else
            {
                data[0]=chEnable0[i-10];
                FlexWrite(startDeviceAddress+1, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            i++;
        }while(i<12);
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE);
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE);
        delay(29150);//delay 110ms
    }
    else
    {
        do
        {
            if(i<2)
            {
                data[0]=chEnable1[i];
                FlexWrite(startDeviceAddress+1, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else if(i<6)
            {
                data[0]=chEnable1[i];
                FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else if(i<8)
            {
                data[0]=chEnable1[i-6];
                FlexWrite(startDeviceAddress, 0x51, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            else
            {
                data[0]=chEnable1[i-6];
                FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_1, TRUE);
                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
            i++;
        }while(i<12);
        data[0]=0x00;
        data[1]=0x00;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE);
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE);
        delay(29150);//delay 110ms
    }

}

void greeting_and_goodbye_2_devices_odd(char startDeviceAddress) //2 devices with device address 1, 2.
{
    unsigned int j,k,m,n;
    char pwmStep[5]={0x00, 0x14, 0x3C, 0xA0, 0xFF}; //defined 4 different brightness steps
    char data[8];

    if(GGFirstRun==1)
    {
        for(n=0;n<2;n++)
        {
            data[0]=0x00;
            FlexWrite(startDeviceAddress+n, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock the device
            for(k=0;k<8;k++)
            {
                data[k]=pwmStep[0];
            }
            FlexWrite(startDeviceAddress+n, 0x20, data, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as pwmStep[0]
            FlexWrite(startDeviceAddress+n, 0x28, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as pwmStep[0]
            data[0]=0x10;
            FlexWrite(startDeviceAddress+n, 0x56, data, DATA_LENGTH_1, TRUE); //enable LUT
            data[0]=0x83;
            FlexWrite(startDeviceAddress+n, 0x57, data, DATA_LENGTH_1, TRUE); //Set PWM frequency as 1000Hz
        }
        data[0]=0x55;
        data[1]=0x05;
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE); //enable device 1
        data[0]=0xAA;
        data[1]=0x0A;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE); //enable device 0

        GGFirstRun=0;
    }

    //***welcome***********************//
    for(j=0;j<4;j++) // 4 different brightness ramp up
    {
        for(m=0;m<6;m++)
        {
            data[0]=pwmStep[j+1]; //assign to next brightness
            FlexWrite(startDeviceAddress, 0x2B-m-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1

            delay(2650);//delay 20ms
            delay(2650);//delay 20ms

            data[0]=pwmStep[j]; //assign back to last brightness
            FlexWrite(startDeviceAddress, 0x2B-m-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1
        }
        for(m=0;m<6;m++)
        {
            data[0]=pwmStep[j+1]; //assign to next brightness
            FlexWrite(startDeviceAddress, 0x2B-m-m, data, DATA_LENGTH_1, TRUE); //ramp up first board from highest channel to lowest channel 1 by 1
            FlexWrite(startDeviceAddress+1, 0x20+m+m, data, DATA_LENGTH_1, TRUE); //ramp up second board from lowest channel to highest channel 1 by 1

            delay(2650);//delay 20ms
            delay(2650);//delay 20ms
        }
    }
    //***follow me home***********************//
        for(j=0;j<4;j++) // 4 different brightness ramp down
        {
            /*
            for(m=0;m<6;m++)
            {
                data[0]=pwmStep[3-j]; //assign to next brightness
                FlexWrite(startDeviceAddress, 0x21+m+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2A-m-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from highest channel to lowest channel 1 by 1

                delay(2650);//delay 20ms
                delay(2650);//delay 20ms

                data[0]=pwmStep[4-j]; //assign back to last brightness
                FlexWrite(startDeviceAddress, 0x21+m+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2A-m-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from highest channel to lowest channel 1 by 1
            }
            */
            for(m=0;m<6;m++)
            {
                data[0]=pwmStep[3-j]; //assign to next brightness
                FlexWrite(startDeviceAddress, 0x21+m+m, data, DATA_LENGTH_1, TRUE); //ramp down first board from lowest channel to highest channel 1 by 1
                FlexWrite(startDeviceAddress+1, 0x2A-m-m, data, DATA_LENGTH_1, TRUE); //ramp down second board from highest channel to lowest channel 1 by 1

                delay(2650);//delay 20ms
                delay(2650);//delay 20ms
            }
        }

}

void meteor_shower(char startDeviceAddress)
{
    char pwmSteps[7]={0xFF, 0xCC, 0x98, 0x65, 0x33, 0x18, 0x0C}; //brightness steps, 100%, 80%, 60%, 40%, 20%, 10%, 5%
    char dataCmd[24]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//store the data wrote to device1-PWMOUT0 - 11 and device2-PWMOUT0 - 11
    char data[8];
    char i=0,j;

    if(firstRun==1)
    {
        data[0]=0x00;
        FlexWrite(startDeviceAddress, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock the device 0
        FlexWrite(startDeviceAddress+1, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock the device 1
        for(j=0;j<8;j++)
        {
            data[j]=0x00;
        }
        FlexWrite(startDeviceAddress, 0x20, data, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as 0x00
        FlexWrite(startDeviceAddress, 0x28, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as 0x00
        FlexWrite(startDeviceAddress, 0x40, data, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMOUT7 as 0x00
        FlexWrite(startDeviceAddress, 0x48, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as 0x00
        FlexWrite(startDeviceAddress+1, 0x20, data, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as 0x00
        FlexWrite(startDeviceAddress+1, 0x28, data, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as 0x00
        data[0]=0x10;
        FlexWrite(startDeviceAddress, 0x56, data, DATA_LENGTH_1, TRUE); //enable LUT for device 0
        FlexWrite(startDeviceAddress+1, 0x56, data, DATA_LENGTH_1, TRUE); //enable LUT for device 1
        data[0]=0xA3;
        FlexWrite(startDeviceAddress, 0x57, data, DATA_LENGTH_1, TRUE); //Set PWM frequency as 2000Hz for device 0
        FlexWrite(startDeviceAddress+1, 0x57, data, DATA_LENGTH_1, TRUE); //Set PWM frequency as 2000Hz for device 1
        data[0]=0xFF;
        data[1]=0x0F;
        FlexWrite(startDeviceAddress, 0x50, data, DATA_LENGTH_2, TRUE); //write 0xFF, 0x0F to 0x50h and 0x51h, enable all channels for the device 0
        FlexWrite(startDeviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE); //write 0xFF, 0x0F to 0x50h and 0x51h, enable all channels for the device 1
        firstRun=0;
    }


    do
    {
        if(i<7)
        {
            for(j=0;j<i+1;j++)
            {
                dataCmd[i-j]=pwmSteps[j];
            }
        }
        else
        {
            for(j=0;j<7;j++)
            {
                if(i-j<24)
                {
                    dataCmd[i-j]=dataCmd[i-j-1];
                }
            }
            dataCmd[i-7]=0;
        }
        FlexWrite(startDeviceAddress, 0x20, dataCmd, DATA_LENGTH_8, TRUE); //write device 0, PWM0-PWM7
        FlexWrite(startDeviceAddress, 0x28, dataCmd+8, DATA_LENGTH_4, TRUE); //write device 0, PWM8-PWM11
        FlexWrite(startDeviceAddress+1, 0x20, dataCmd+12, DATA_LENGTH_8, TRUE); //write device 1, PWM0-PWM7
        FlexWrite(startDeviceAddress+1, 0x28, dataCmd+20, DATA_LENGTH_4, TRUE); //write device 1, PWM8-PWM11
        i++;

        delay(2650); //delay 20ms
      //  delay(2650); //delay 20ms
      //  delay(2650); //delay 20ms
    }while(i<31);
}

