#include <msp430.h> 
#include <FlexLED.h>


unsigned int timeOutFlag=0;
char patternMode=0;
char GGFirstRun=1;
char firstRun=1; //flag of whether the welcome and goodbye pattern is first running
char turnFirstRun=1; //flag of whether the turn pattern is first running
char crcArray[256]; //store the CRC value of data from 0x00 to 0xFF
extern char dmaTxData[100];
/**
 * main.c
 */
int main(void)
{

	WDTCTL = WDTPW | WDTHOLD;	// stop watchdog timer
	
	__bis_SR_register(GIE);

	unsigned int i;
	char data[20], deviceAddress, dataHigh[8], dataLow[8];

	portInitial();
	timerInitial();
	uartInitial();
	crcInitial(); //calculate and store the CRC of data from 0x00 to 0xFF
	ucsInitial(); //set the ACLK and SMCLK
	dmaInitial(); //DMA Initialize


	deviceAddress = DEV_ADDR_0;

	delay(26500);//delay 200ms
    delay(26500);//delay 200ms
    delay(26500);//delay 200ms
    delay(26500);//delay 200ms
    delay(26500);//delay 200ms

    data[0]=0x00;
    FlexWrite(deviceAddress, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock device 0
    FlexWrite(deviceAddress+1, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock device 1

    data[0]=0x03;
    FlexWrite(deviceAddress, 0x60, data, DATA_LENGTH_1, TRUE); //write 0x03 to 0x60h, Clear POR, FAULT for device 0
    FlexWrite(deviceAddress+1, 0x60, data, DATA_LENGTH_1, TRUE); //write 0x03 to 0x60h, Clear POR, FAULT for device 1

    data[0]=0xA3;
    FlexWrite(deviceAddress, 0x57, data, DATA_LENGTH_1, TRUE); //write 0xA3 to 0x57h, set PWMFREQ=2000Hz, REFRANGE=512 for device 0
    FlexWrite(deviceAddress+1, 0x57, data, DATA_LENGTH_1, TRUE); //write 0xA3 to 0x57h, set PWMFREQ=2000Hz, REFRANGE=512 for device 1

    //***Set DC for all Channels
    for(i=0;i<8;i++)
      {
          data[i]=0x3F;
      }
     FlexWrite(deviceAddress, 0x00, data, DATA_LENGTH_8, TRUE); //write CONF_IOUT0 to CONF_IOUT7 as 0x1F
     FlexWrite(deviceAddress, 0x08, data, DATA_LENGTH_4, TRUE); //write CONF_IOUT8 to CONF_IOUT11 as 0x1F
     for(i=0;i<8;i++)
       {
           data[i]=0x3F;
       }
     FlexWrite(deviceAddress+1, 0x00, data, DATA_LENGTH_8, TRUE); //write CONF_IOUT0 to CONF_IOUT7 as 0x1F
     FlexWrite(deviceAddress+1, 0x08, data, DATA_LENGTH_4, TRUE); //write CONF_IOUT8 to CONF_IOUT11 as 0x1F

     //***Set PWMOUT for all Channels
    for(i=0;i<8;i++)
    {
         dataLow[i]=15;
         dataHigh[i]=255; //255 -- 100%, 127 -- 50%, 25 -- 10%
    }
     FlexWrite(deviceAddress, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
     FlexWrite(deviceAddress, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow
     FlexWrite(deviceAddress+1, 0x40, dataLow, DATA_LENGTH_8, TRUE); //write CONF_PWMLOWOUT0 to CONF_PWMLOWOUT7 as dataLow
     FlexWrite(deviceAddress+1, 0x48, dataLow, DATA_LENGTH_4, TRUE); //write CONF_PWMLOWOUT8 to CONF_PWMLOWOUT11 as dataLow

     FlexWrite(deviceAddress, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
     FlexWrite(deviceAddress, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh
     FlexWrite(deviceAddress+1, 0x20, dataHigh, DATA_LENGTH_8, TRUE); //write CONF_PWMOUT0 to CONF_PWMOUT7 as dataHigh
     FlexWrite(deviceAddress+1, 0x28, dataHigh, DATA_LENGTH_4, TRUE); //write CONF_PWMOUT8 to CONF_PWMOUT11 as dataHigh


//     ***Enable all channels for device 0
     data[0]=0xFF;
     data[1]=0x0F;
     FlexWrite(deviceAddress, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x03 to 0x60h, Clear POR, FAULT for device 0

//     ***Enable all channels for device 1
     data[0]=0xFF;
     data[1]=0x0F;
     FlexWrite(deviceAddress+1, 0x50, data, DATA_LENGTH_2, TRUE); //write 0x03 to 0x60h, Clear POR, FAULT for device 0
//
//     ***Lock device 0 registers
     data[0]=0x0B;
     FlexWrite(deviceAddress, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock device 0
//
//     ***Lock device 1 registers
     data[0]=0x0B;
     FlexWrite(deviceAddress+1, 0x61, data, DATA_LENGTH_1, TRUE); //write 0x00 to 0x61h, unlock device 0


	while(1)
	{
	    if(patternMode==0)
	    {
	        firstRun=1;
	        GGFirstRun=1;
	        turnLeft(deviceAddress,0);
	    }
	    else if(patternMode==1)
	    {
            firstRun=1;
            GGFirstRun=1;
            turnLeft(deviceAddress,1);
	    }
//	    else if(patternMode==2)
//	    {
//	        firstRun=1;
//	        GGFirstRun=1;
//	        turnLeft_odd(deviceAddress,0);
//	    }
//        else if(patternMode==3)
//       {
//            firstRun=1;
//            GGFirstRun=1;
//            turnLeft_odd(deviceAddress,1);
//        }
	    else //if(patternMode==2)
	    {
	        turnFirstRun=1;
	        GGFirstRun=1;
	        greeting_and_goodbye_2_devices(deviceAddress);
	    }
//	    else if(patternMode==5)
//	    {
//	        turnFirstRun=1;
//	        firstRun=1;
//	        greeting_and_goodbye_2_devices_odd(deviceAddress);
//	    }
//	    else
//	    {
//            turnFirstRun=1;
//            GGFirstRun=1;
//            meteor_shower(deviceAddress);
//	    }
	}
	return 0;
}
